package bdc;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;

public class ProductForm extends ActionForm {

  protected String productid;
  protected String productname;
  protected String category;
  protected String quantity;
  protected String flag;
  protected String price;
  protected String image;
  protected String total;

  public void setProductid(String productid)
  {
    this.productid = productid;
  }

  public String getProductid()
  {
    return productid;
  }

  public void setProductname(String productname)
  {
    this.productname = productname;
  }

  public String getProductname()
  {
    return productname;
  }

  public void setCategory(String category)
  {
    this.category = category;
  }

  public String getCategory()
  {
    return category;
  }

  public void setQuantity(String quantity)
  {
    this.quantity = quantity;
  }

  public String getQuantity()
  {
    return quantity;
  }

  public void setFlag(String flag)
  {
    this.flag = flag;
  }

  public String getFlag()
  {
    return flag;
  }

  public void setPrice(String price)
  {
      this.price = price;
  }

  public String getPrice()
  {
      return price;
  }


  public void setImage(String image)
  {
        this.image = image;
  }

  public String getImage()
  {
        return image;
  }

 public void setTotal(String total)
  {
        this.total = total;
  }

  public String getTotal()
  {
        return total;
  }











  // Called Everytime, Resets the form attributes
  //before sending values, in new request
 public void reset(ActionMapping mapping, HttpServletRequest request)
  {

	this.productid = "";
	this.productname = "";
	this.category = "";
	this.quantity = "";
	this.flag = "";
	this.price = "";
	this.image = "";

  }

  public ActionErrors validate(ActionMapping mapping,
    HttpServletRequest request) {

    ActionErrors errors = new ActionErrors();

    LoginActionMapping loginMapping =
      (LoginActionMapping)mapping;

    // Check to see whether user needs to be logged in
    if ( loginMapping.isLoginRequired() ) {

      HttpSession session = request.getSession();
      if ( session.getAttribute("USER") == null ) {

        //force login
        return null;
      }
    }


    if ( (productname == null ) || (productname.length() == 0) ) {

      errors.add("productname", new ActionError("errors.productname.required"));
    }

    if ( (category == null ) || (category.length() == 0) ) {

      errors.add("category", new ActionError("errors.category.required"));
    }

    if ( (quantity == null ) || (quantity.length() == 0) ) {

      errors.add("quantity", new ActionError("errors.quantity.required"));
    }

    if ( (flag == null ) || (flag.length() == 0) ) {

      errors.add("flag", new ActionError("errors.flag.required"));
    }
   if ( (price == null ) || (price.length() == 0) ) {

	      errors.add("price", new ActionError("errors.price.required"));
    }

    return errors;
  }
}
