package bdc;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;
import org.apache.struts.Globals;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.ArrayList;

public class ProductListAction extends Action {

  protected ArrayList getProduct()


  {

    Product product = null;
    ArrayList products = new ArrayList();
    Connection conn = null;
    Statement stmt = null;
    ResultSet rs = null;

    ServletContext context = servlet.getServletContext();
    DataSource dataSource = (DataSource)
      context.getAttribute(Globals.DATA_SOURCE_KEY);

    try {

      conn = dataSource.getConnection();
      stmt = conn.createStatement();
      rs =
        stmt.executeQuery("select * from product");

      while ( rs.next() ) {

        product = new Product();

        product.setProductId(rs.getString("productid"));
        product.setName(rs.getString("name"));
        product.setCategory(rs.getString("category"));
        product.setQuantity(rs.getString("quantity"));
        product.setFlag(rs.getString("flag"));


        products.add(product);

        System.err.println("Product name : " + product.getName());
      }
    }
    catch (SQLException e) {

      System.err.println(e.getMessage());
    }
    finally {

      if (rs != null) {

        try {

          rs.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        rs = null;
      }
      if (stmt != null) {

        try {

          stmt.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        stmt = null;
      }
      if (conn != null) {

        try {

          conn.close();
        }
        catch (SQLException sqle) {

          System.err.println(sqle.getMessage());
        }
        conn = null;
      }
    }
    return products;
  }

	public ActionForward perform(ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws IOException, ServletException
	{

	// Default target is success
    String target = new String("success");

    LoginActionMapping loginMapping =
      (LoginActionMapping)mapping;

    // Check if login needed
    if (loginMapping.isLoginRequired() )
    {

      HttpSession session = request.getSession();

      if ( session.getAttribute("USER") == null )
      {

        // User not logged in
        target = new String("login");
        ActionErrors errors = new ActionErrors();

        errors.add(ActionErrors.GLOBAL_ERROR,
          new ActionError("errors.login.required"));

        //Report errors back to calling form
        if (errors!=null)
        {
          saveErrors(request, errors);
        }
      }
    }

    ArrayList products = null;

    products = getProducts();

    // Target set to failure
    if ( products == null ) {

      target = new String("login");
    }
    else {

      request.setAttribute("products", products);
    }
	  // Forward to the appropriate View
	  return (mapping.findForward(target));
	}
}